﻿using Steema.TeeChart;
using Steema.TeeChart.Styles;
using System.Diagnostics;

namespace TeeChartMockUpDemos
{
    public partial class CandleChart : ContentPage
    {
        //  ***** Added Code ******
        private MouseDrag _MouseDrag;
        private int _Count;


        public CandleChart()
        {
            InitializeComponent();
            view3D.CheckedChanged += View3D_CheckedChanged;
            var CandleChart = new Candle(tChart1.Chart);
            CandleChart.FillSampleValues();

            //  ***** Added Code ******
            _MouseDrag = new MouseDrag(tChart1, MouseDrag.DragActions.Zoom);

            //... SetTChartZoomProperties();
        }

        #region  ***** Added Code Here *****
        private void SetTChartZoomProperties()
        {
            tChart1.Panning.Active = false;
            tChart1.Panning.Allow = ScrollModes.None;

            tChart1.Zoom.Active = true;
            tChart1.Zoom.Direction = ZoomDirections.Horizontal;

            if (_Count == 0)
            {
                tChart1.Zoomed += TChart1_Zoomed;
                tChart1.UndoneZoom += TChart1_UndoneZoom;
            }
        }

        private void TChart1_UndoneZoom(object sender, EventArgs e)
        {
            Trace.WriteLine(_Count++ + "  UnZoomed: " + !tChart1.Zoom.Zoomed);
            SetTChartZoomProperties();
        }

        private void TChart1_Zoomed(object sender, EventArgs e)
        {
            Trace.WriteLine(_Count++ + "  Zoomed: " + tChart1.Zoom.Zoomed);
            var zoomed = tChart1.Zoom.Zoomed;
            SetTChartZoomProperties();
        }
        #endregion

        private void View3D_CheckedChanged(object sender, CheckedChangedEventArgs e)
        {
            tChart1.Chart.Aspect.View3D = e.Value;
            InvalidateMeasure();

            if (_MouseDrag.DragAction == MouseDrag.DragActions.Pan)
                _MouseDrag.SetDragAction(MouseDrag.DragActions.Zoom);
            else
                _MouseDrag.SetDragAction(MouseDrag.DragActions.Pan);
        }
    }
}
